// JJUpdate.cpp : AvP[VpNX̒`s܂B
//
/////////////////////////////////////////////////////////////////////////////
//
// Program by Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// JJUpdateFAvP[VNX
// Last update	2005.03.21
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JJUpdate.h"
#include "JJUpdateDlg.h"

#include <afxinet.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// y[Wf[^̃obt@ő
#define		INET_GET_BUFF_MAX	4096

// 𓀃Cũt@C
static _TCHAR *tarLibFile =
{
	_T("TAR32.DLL")
};

// 𓀃R}h̐`  
// %0= 0:vOX\ 1:\
// %1= 'archiveName.gz' itpXj
// %2= 'c:\meltedPath'	itpXj
// --use-directory=0 ́AfBNg𖳎
static _TCHAR *meltCommand =
{
	_T("--use-directory=0 --display-dialog=%0 xvf \"%1\" -o \"%2\"")
};


/////////////////////////////////////////////////////////////////////////////
// CJJUpdateApp
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CJJUpdateApp, CWinApp)
	//{{AFX_MSG_MAP(CJJUpdateApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJJUpdateApp NX̍\z

/*-------------------------------------------------------------------------*/
// CJJUpdateApp				RXgN^
/*-------------------------------------------------------------------------*/
CJJUpdateApp::CJJUpdateApp()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
}

/////////////////////////////////////////////////////////////////////////////
// B CJJUpdateApp IuWFNg

CJJUpdateApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CJJUpdateApp NX̏

/*-------------------------------------------------------------------------*/
// InitInstance				AvP[VCX^X̏
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateApp::InitInstance()
{
	AfxEnableControlContainer();

	// WIȏ
	// ̋@\gpAst@C̃TCY
	//  Έȉ̓̏[`̒sKvȂ̂폜
	//  B

#ifdef _AFXDLL
	Enable3dControls();			// L DLL  MFC gꍇ͂R[ĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNꍇ͂R[ĂB
#endif

	// p^̉
	CMyCommandLineInfo	cmdInfo;
	ParseCommandLine(cmdInfo);

	// WXggpȂŁAINI gp
	CString	theIntFIie = GetAppPath();
	free((void*)m_pszProfileName);
	if (cmdInfo.m_IniFile.IsEmpty())	{
		// ftHg̐ݒt@C
		theIntFIie += _T("JJUpdate.ini");
	}
	else	{
		// p^w̐ݒt@C
		theIntFIie += cmdInfo.m_IniFile;
	}
	m_pszProfileName=_tcsdup(theIntFIie);

	// INI ̓ǂݍ
	if (!LoadSetting())	return FALSE;

	CJJUpdateDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: _CAO <OK> ŏꂽ̃R[h
		//       LqĂB
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: _CAO <ݾ> ŏꂽ̃R[h
		//       LqĂB
	}

	// A[JCupX̃t@C폜
	DoArchiveFileAllDelete();

	// _CAOĂAvP[ṼbZ[W |vJńA
	// AvP[VI邽߂ FALSE ԂĂB
	return FALSE;
}

// p^̓R[obN
void CMyCommandLineInfo::ParseParam(
        LPCTSTR theParamP, BOOL isOption, BOOL isLast )
{
    // isOption : IvVłꍇɂP
    // isLast   : Ō̈łꍇɂP
    TRACE(_T("Param:%s isOption=%d isLast=%d\n"),theParamP,isOption,isLast);
	CString	theFileName = theParamP;
	if (!theFileName.IsEmpty())	{
		CFileStatus	theFSta;
		if (CFile::GetStatus(theApp.GetAppPath() + theFileName,theFSta))	{
			m_IniFile = theFileName;
		}
	}
}

/*-------------------------------------------------------------------------*/
// LoadSetting						INI ̓ǂݍ
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateApp::LoadSetting()
{

	// ^Cg
	m_Title = GetProfileString(_T("Archive"),_T("Title"));

	// T[oURL
	m_Url = GetProfileString(_T("Archive"),_T("URL"));
	if (m_Url.IsEmpty())	{
		AfxMessageBox(_T("ݒ̧قɎMURL̋Lq܂B"));
		return FALSE;
	}

	// [JɓWJe|pX
	m_ArchiveTempPath = GetProfileString(_T("Archive"),_T("TempFolder"));
	if (m_ArchiveTempPath.IsEmpty())	{
		m_ArchiveTempPath = _T("UpdateArchive");
	}

	// e|pXꍇ͍쐬
	CFileStatus theFSta;
	CString	theFolder	= GetAppPath() + m_ArchiveTempPath + _T("\\");
	if (!CFile::GetStatus(theFolder,theFSta))	{
		::CreateDirectory(theFolder,NULL);
	}

	// ÑvO
	m_AutoRunPgm = GetProfileString(_T("AutoRun"),_T("Program"));
	m_UpdateDoc  = GetProfileString(_T("AutoRun"),_T("UpdateDoc"));
	return TRUE;
}

/*-------------------------------------------------------------------------*/
// GetAppPath		AvP[ṼtpXo
/*-------------------------------------------------------------------------*/
CString CJJUpdateApp::GetAppPath()
{
	// AvP[VpX擾
	// iftHg̃wvt@CpX擾j
	_TCHAR	appPath[MAX_PATH+1] = _T("");
	_tcscpy(appPath,m_pszHelpFilePath);
	for (INT i=_tcslen(appPath)-1;i>=0;i--)	{
		// ŏ \ ܂ŃJbg
		if (appPath[i] == '\\')	{
			appPath[i+1] = 0x0;
			break;
		}
	}
	return	CString(appPath);
}

/*-------------------------------------------------------------------------*/
// GetUpdateArchive		wtqk̃Abvf[gA[JCu̎擾
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateApp::GetUpdateArchive(LIST_DATA_TBL*	inListData,INT* outUpdateCount)
{
	// XV`FbNtO𗎂ƂĂ
	*outUpdateCount = 0;

	// A[JCuot@C擾
	CString	theArchiveFilePath = GetAppPath() + m_ArchiveTempPath + _T("\\Archive.zip");

	// o̓t@C쐬
	CFile	theOutFile;
	if (!theOutFile.Open(theArchiveFilePath,CFile::modeCreate + CFile::modeWrite))	{
		// G[
		CString	theMsg;
		theMsg.Format(_T("Ļق쐬ł܂B\r\n\r\n%s"),theOutFile);
		AfxMessageBox(theMsg);
		return FALSE;
	}

	// ZV𒣂
	CWaitCursor wait;
	BOOL	result = TRUE;
	CHAR	theBuff[INET_GET_BUFF_MAX + 1];
	CInternetSession theSession(_T("JJUpdate Session"));
	try	
	{
		CFile* theUrlStream = theSession.OpenURL(m_Url);
		if (theUrlStream != NULL)	{
			UINT	theLength = theUrlStream->Read(theBuff,INET_GET_BUFF_MAX);
			while (theLength > 0)	{
				// t@Co
				theOutFile.Write(theBuff,theLength);
				theLength = theUrlStream->Read(theBuff,INET_GET_BUFF_MAX);
			}
			delete theUrlStream;
		}
		else	{
			// G[
			CString	theMsg;
			theMsg.Format(_T("LURL݂ł܂B\r\n\r\n%s"),m_Url);
			AfxMessageBox(theMsg);
			result = FALSE;
		}
	}
	catch	(...)	
	{
		// G[
		CString	theMsg;
		theMsg.Format(_T("ްMɴװN܂B\r\n\r\n%s"),m_Url);
		AfxMessageBox(theMsg);
		result = FALSE;
	}

	// n
	theSession.Close();
	theOutFile.Close();

	if (result)	{
		// A[JCủ
		if (DoArchiveMelt())	{
			// 𓀃t@C`FbN
			LIST_DATA_TBL*	theItemP = inListData;
			INT	i = 0;
			while (theItemP)	{
				CString	theFilePath = GetAppPath() + m_ArchiveTempPath;
				GetFileUpdateYmd(1,theItemP->FileName,theItemP->UpdateYmd,20,&theItemP->UpdateSize);
				// Xe[^X̕ύX
				if (theItemP->UpdateSize > 0)	{
					// XVt@Ĉ݂̂
					if (_tcscmp(theItemP->NowYmd,theItemP->UpdateYmd) == 0	&&
						theItemP->NowSize == theItemP->UpdateSize)	{
						// XV̕Kv
						theItemP->Status = 2;
					}
					else	{
						// XV̕KvL
						theItemP->Status = 1;
						(*outUpdateCount)++;
					}
				}
				// ̃N
				theItemP = theItemP->NextItemP;
			}
		}
	}

	return result;
}

/*-------------------------------------------------------------------------*/
// DoArchiveMelt		Abvf[gA[JCủ
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateApp::DoArchiveMelt()
{
	// 𓀃pXƃA[JCut@C擾
	CString	theMeltPath = GetAppPath() + m_ArchiveTempPath;
	CString	theArchiveFilePath = theMeltPath + _T("\\Archive.zip");

	// 𓀃R}hg
	CString	theCommand(meltCommand);
#ifdef _DEBUG
	// fobOȌꍇ̓vOXo[\
	VERIFY(theCommand.Replace(_T("%0"),_T("1")));
#else
	// [Xł̓vOXo[͕\Ȃ
	VERIFY(theCommand.Replace(_T("%0"),_T("0")));
#endif
	VERIFY(theCommand.Replace(_T("%1"),theArchiveFilePath));
	VERIFY(theCommand.Replace(_T("%2"),theMeltPath));


	// 𓀏
	BOOL	result = TRUE;
	const	INT TAR_DLL_MSGBUFF = 1024;
	char*	theDllMsgbuff = new char[TAR_DLL_MSGBUFF+1];
	if (theDllMsgbuff != NULL)	{
		HINSTANCE hLib = ::LoadLibrary(tarLibFile);
		INT (WINAPI *TarTarSource)(HWND hwnd,char *cmd,char *buff,INT buflen);
		hLib = LoadLibrary("tar32.dll");
		TarTarSource = (INT(__stdcall *)(struct HWND__ *,char *,char *,INT))GetProcAddress(hLib,"Tar");
		result = (0 == TarTarSource(NULL,(char*)LPCTSTR(theCommand),theDllMsgbuff,TAR_DLL_MSGBUFF));
		::FreeLibrary(hLib);
		delete [] theDllMsgbuff;
	}
	else	{
		result = FALSE;
	}
	if (!result)	{
		// 𓀎s
		CString	theMsg;
		theMsg.Format(_T("ް𓀒ɴװN܂B\r\n\r\n%s"),theCommand);
		AfxMessageBox(theMsg);
	}

	return result;
}

/*-------------------------------------------------------------------------*/
// DoUpdate				XV
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateApp::DoUpdate(LIST_DATA_TBL*	inListData)
{
	// 𓀃t@C`FbN
	LIST_DATA_TBL*	theItemP = inListData;
	BOOL	result = TRUE;
	while (theItemP)	{
		// XV̂̂݃Rs[(G[܂)
		if (theItemP->Status ==  1 || theItemP->Status ==  9)	{
			CString	theArcFilePath = GetAppPath() + m_ArchiveTempPath + _T("\\") + theItemP->FileName;
			CString	theOrgFilePath = GetAppPath() + theItemP->FilePath + theItemP->FileName;
			if (::CopyFile(theArcFilePath,theOrgFilePath,FALSE))	{
				// 
				theItemP->Status = 3;
			}
			else	{
				// s
				theItemP->Status = 9;
				result = FALSE;
			}
		}
		// ̃N
		theItemP = theItemP->NextItemP;
	}

	return result;
}

/*-------------------------------------------------------------------------*/
// DoArchiveFileAllDelete		A[JCupX̃t@CSč폜
/*-------------------------------------------------------------------------*/
void CJJUpdateApp::DoArchiveFileAllDelete()
{
	// A[JCupXpXXL
	CString	theMask = GetAppPath() + m_ArchiveTempPath + CString(_T("\\*.*"));
	CFileFind		theFinder;
	CStringArray	theFileNameArray;
	INT				theCount = 0;
	BOOL itFound = theFinder.FindFile(theMask);
	while (itFound)	{
		itFound = theFinder.FindNextFile();
		CString	theFileName = theFinder.GetFileName();
		if (theFileName != _T(".") && theFileName != _T(".."))	{
			theFileNameArray.Add(theFileName);
			theCount++;
		}
	}

	// t@C폜
	for (INT i=0;i<theCount;i++)	{
		CString	theDelFileName = GetAppPath() + m_ArchiveTempPath + _T("\\") + theFileNameArray[i];
		::DeleteFile(theDelFileName);
	}
}

/*-------------------------------------------------------------------------*/
// GetFileUpdateYmd		wXVt@C̍ŏIXVN擾
/*-------------------------------------------------------------------------*/
TCHAR* CJJUpdateApp::GetFileUpdateYmd(
		INT inMode,CString inFileName,TCHAR* outYmd,UINT inMaxLen,INT* outFileSize)
{
	// "yyyy/mm/dd hh:mm:ss" ɕҏW
	// inMode 0=݁A1=_E[hA[JCu


	if (outYmd && outFileSize)	{
		memset(outYmd,0x0,inMaxLen);
		*outFileSize = 0;
		CString	theFilePath = _T("");
		if (inMode == 0)	{
			// ݂̃t@C
			theFilePath = GetAppPath() + inFileName;
		}
		else	{
			// _E[hA[JCũt@C
			theFilePath = GetAppPath() + m_ArchiveTempPath + _T("\\") + inFileName;
		}
		// t@C݃`FbN
		CFileStatus theFSta;
		if (CFile::GetStatus(theFilePath,theFSta))	{
			// XVҏW
			CString	theYmd = theFSta.m_mtime.Format(_T("%Y/%m/%d %H:%M:%S"));
			_tcsncpy(outYmd,theYmd,__min((INT)inMaxLen,theYmd.GetLength()));	
			// TCY
			*outFileSize = theFSta.m_size;
		}	

	}
	return outYmd;
}

/*-------------------------------------------------------------------------*/
// DoAutoRun		svŐN
/*-------------------------------------------------------------------------*/
void CJJUpdateApp::DoAutoRun(BOOL isDocShow)
{
	CString	theMsg;
	
	// vON
	if (!m_AutoRunPgm.IsEmpty())	{
		/*
		theMsg.Format(_T("%s[%s]\r\n\r\nL۸тN܂B"),
			m_Title,m_AutoRunPgm);
		if (IDOK != AfxMessageBox(theMsg,MB_OKCANCEL+MB_ICONINFORMATION))	return;
		*/
		CString	theCommand;
		theCommand.Format(_T("\"%s\""),GetAppPath() + m_AutoRunPgm);
		if (!DoLaunch(theCommand))	{
			theMsg.Format(_T("L۸т̋NɎs܂B\r\n\r\n%s"),theCommand);
			AfxMessageBox(theMsg);
		}
	}

	// hLgI[v
	if (isDocShow && !m_UpdateDoc.IsEmpty())	{
		CString	theCommand = GetAppPath() + m_UpdateDoc;	
		HINSTANCE	hInst = ::ShellExecute(NULL,_T("open"),theCommand,NULL,NULL,SW_SHOWNORMAL);
		if (hInst < (HINSTANCE)32)	{
			theMsg.Format(_T("L޷ĂJ܂B\r\n\r\n%d"),theCommand);
			AfxMessageBox(theMsg);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// ʃTu[`Q
/////////////////////////////////////////////////////////////////////////////

/*-------------------------------------------------------------------------*/
// GetVS_VERSION_INFO		t@Co[Wƒ쌠擾
/*-------------------------------------------------------------------------*/
void GetVS_VERSION_INFO(CString& outVerStr,CString& outCopyrightStr)
{
	struct LANGANDCODEPAGE {
		WORD	Language;
		WORD	CodePage;
	} *theTranslateP;

	CString	thePrgName;
	thePrgName.Format(_T("%s.exe"),AfxGetApp()->m_pszExeName);

	UINT	theLen		= 0;
	// t@Co[W̒擾
	INT		theBuffSize = thePrgName.GetLength();
	DWORD	theDataLen	= ::GetFileVersionInfoSize(thePrgName.GetBuffer(theBuffSize), 0);
	// t@Co[Wi[̈擾
	_TCHAR* theInfoP = new _TCHAR[theDataLen];

	// t@Co[W擾
	BOOL result = ::GetFileVersionInfo(thePrgName.GetBuffer(theBuffSize),0,theDataLen,theInfoP);
	if (result){
		result = ::VerQueryValue(theInfoP,TEXT("\\VarFileInfo\\Translation"),(LPVOID*)&theTranslateP,&theLen);
		if (result){
			UINT	theVarueLen;
			void	*theVarueP=NULL;
			_TCHAR	theSubBlockP[256];
			// io[W
			for(UINT i=0; i < (theLen/sizeof(struct LANGANDCODEPAGE)); i++ ){
				wsprintf( theSubBlockP, TEXT("\\StringFileInfo\\%04x%04x\\ProductVersion"),
					theTranslateP[i].Language,theTranslateP[i].CodePage);
				result = ::VerQueryValue(theInfoP, theSubBlockP, &theVarueP, &theVarueLen);
				if (result){
					// theVaruePPuroductVersionĂ
					outVerStr = (_TCHAR*)theVarueP;
					break;
				}
			}
			// 쌠
			for(i=0; i < (theLen/sizeof(struct LANGANDCODEPAGE)); i++ ){
				wsprintf( theSubBlockP, TEXT("\\StringFileInfo\\%04x%04x\\LegalCopyright"),
					theTranslateP[i].Language,theTranslateP[i].CodePage);
				result = ::VerQueryValue(theInfoP, theSubBlockP, &theVarueP, &theVarueLen);
				if (result){
					// theVaruePCopyrightĂ
					outCopyrightStr = (_TCHAR*)theVarueP;
					break;
				}
			}
		}
	}
	if (theInfoP)	delete [] theInfoP;
}

/*-------------------------------------------------------------------------*/
// DoLaunch			R}hwŃAvP[V`
/*-------------------------------------------------------------------------*/
BOOL DoLaunch(CString inCommand,WORD inShowWindow)
{
	BOOL	result = FALSE;
	// NvZX̕\EBhE̐ݒ
	STARTUPINFO theStartupInfo = {sizeof(STARTUPINFO)};
	theStartupInfo.dwFlags = STARTF_USESHOWWINDOW;
	theStartupInfo.wShowWindow = inShowWindow;

	// vZXNiR}hsj
	PROCESS_INFORMATION	pi;
	if (0 != ::CreateProcess(NULL,(_TCHAR*)LPCTSTR(inCommand),
						NULL,NULL,FALSE,CREATE_NEW_PROCESS_GROUP,
						NULL,NULL,&theStartupInfo,&pi))	{
		// Kv̂Ȃnh
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
		// `
		result = TRUE;
	}
	return result;
}
