// JJUpdateDlg.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////
//
// Program by Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// JJUpdateFCEBhENX
// Last update	2005.03.21
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JJUpdate.h"
#include "JJUpdateDlg.h"
#include "UrlStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B CJJUpdateApp IuWFNg

extern	CJJUpdateApp theApp;



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO
/////////////////////////////////////////////////////////////////////////////

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CUrlStatic	m_UrlStatic;
	CString	m_Copyright;
	CString	m_Version;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	CString	theVersion,theCopyright;
	GetVS_VERSION_INFO(theVersion,theCopyright);
	CString	theFmt;
	theFmt.Format(_T("%s Version %s"),AfxGetApp()->m_pszExeName,theVersion);
	//{{AFX_DATA_INIT(CAboutDlg)
	m_Copyright	= theCopyright;
	m_Version	= theFmt;
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC_URL, m_UrlStatic);
	DDX_Text(pDX, IDC_STATIC_COPYRIGHT, m_Copyright);
	DDX_Text(pDX, IDC_STATIC_VERSION, m_Version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CJJUpdateDlg _CAO
/////////////////////////////////////////////////////////////////////////////

/*-------------------------------------------------------------------------*/
// CJJUpdateDlg				RXgN^
/*-------------------------------------------------------------------------*/
CJJUpdateDlg::CJJUpdateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJJUpdateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJJUpdateDlg)
	m_Url = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Url   = theApp.m_Url;
}

/*-------------------------------------------------------------------------*/
// DoDataExchange			_CAOf[^GNX`FW
/*-------------------------------------------------------------------------*/
void CJJUpdateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJJUpdateDlg)
	DDX_Control(pDX, ID_UPDATE, m_BtnUpdate);
	DDX_Control(pDX, IDCANCEL, m_BtnCancel);
	DDX_Control(pDX, IDOK, m_BtnOk);
	DDX_Control(pDX, IDC_LIST, m_List);
	DDX_Text(pDX, IDC_STATIC_INFO, m_Url);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJJUpdateDlg, CDialog)
	//{{AFX_MSG_MAP(CJJUpdateDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_UPDATE, OnUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJJUpdateDlg bZ[W nh

/*-------------------------------------------------------------------------*/
// OnInitDialog				_CAOiCEBhEjݒ
/*-------------------------------------------------------------------------*/
BOOL CJJUpdateDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ACR̐ݒ
	SetIcon(m_hIcon, TRUE);		// ACRݒ
	
	// Xg̏ݒ
	m_List.Initial(30);

	// TODO:XgRg[𗘗pƂ̒
	// Xg̍sύX
	// ̏ƁAWM_WINDOWPOSCHANGEDbZ[WsȂ
	// s̍w肪oȂ
	// CListCtrlEx::MeasureItemĂ΂Ȃj
	// TCYWM_WINDOWPOSCHANGEDŝŁAL̂悤
	// PhbgTCYɍLĂ
	CRect	theRc;
	m_List.GetWindowRect(&theRc);
	ScreenToClient(&theRc);
	theRc.bottom++;
	m_List.MoveWindow(theRc);

	// ^Cg̏C
	CString	theCaption,theNewCaption;
	GetWindowText(theCaption);
	theNewCaption.Format(theCaption,theApp.m_Title);
	SetWindowText(theNewCaption);

	// XV{^𖳌
	m_BtnUpdate.EnableWindow(FALSE);
	
	return TRUE;
}

/*-------------------------------------------------------------------------*/
// OnSysCommand				VXej[iAoEgǉj
/*-------------------------------------------------------------------------*/
void CJJUpdateDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CJJUpdateDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CJJUpdateDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/*-------------------------------------------------------------------------*/
// OnOK					WEBڑXV`FbN
/*-------------------------------------------------------------------------*/
void CJJUpdateDlg::OnOK() 
{
	INT	theUpdateCount = 0;
	if (theApp.GetUpdateArchive(m_List.GetListData(),&theUpdateCount))	{
		m_List.RedrawWindow();		// XgXV
		m_BtnOk.EnableWindow(FALSE);
		if (theUpdateCount > 0)	{
			// XV̕Kv
			m_BtnCancel.SetWindowText("~");
			m_BtnUpdate.EnableWindow(TRUE);
			m_BtnUpdate.SetFocus();
			CString	theMsg;
			theMsg.Format(_T("%d̍XV̧ق܂B\r\nmF̏AXV{^ĂB"),theUpdateCount);
			AfxMessageBox(theMsg,MB_ICONINFORMATION);
		}
		else	{
			// XV̕KvȂ
			AfxMessageBox(_T("VXV̧ق͂܂B\r\nI܂B"),MB_ICONINFORMATION);
			// vOI
			CDialog::OnOK();
			// w̋NvOJn
			theApp.DoAutoRun(FALSE);
		}
	}

}

/*-------------------------------------------------------------------------*/
// OnUpdate				XV
/*-------------------------------------------------------------------------*/
void CJJUpdateDlg::OnUpdate() 
{
	BOOL	result = theApp.DoUpdate(m_List.GetListData());	
	m_List.RedrawWindow();		// XgXV
	if (result)	{
		// XV
		AfxMessageBox(_T("XV͑SĊ܂B\r\nI܂B"),MB_ICONINFORMATION);
		// w̋NvOJn
		theApp.DoAutoRun(TRUE);
		// vOI
		CDialog::OnOK();
	}
	else	{
		// XV̕KvȂ
		AfxMessageBox(_T("XVŴװNĂ܂B\r\nXVΏ۸тNĂƍXV͎s܂B\r\n̏ꍇ́AΏ۸тIčēxXV{^ĂB"),MB_ICONINFORMATION);
	}
}

/*-------------------------------------------------------------------------*/
// OnCancel				~̊mF
/*-------------------------------------------------------------------------*/
void CJJUpdateDlg::OnCancel() 
{
	CString	theCaption;
	m_BtnCancel.GetWindowText(theCaption);
	if (theCaption == _T("~"))	{
		if (IDOK != AfxMessageBox(_T("XV̧ق܂B\r\n̂܂܏IĂ낵łH"),MB_ICONQUESTION + MB_OKCANCEL))	return;
	}
	
	CDialog::OnCancel();
}
