/////////////////////////////////////////////////////////////////////////////
//
// Program by Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// ListCtrlEx.cpp
//
// XgRg[̃|[gr[sIgNX
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ListCtrlEx.h"
#include <afxole.h>
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CObject::IsKindOf 𗘗p̂߂
IMPLEMENT_DYNAMIC(CListCtrlEx,CListCtrl)

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx

/*-------------------------------------------------------------------------*/
// CListCtrlEx		RXgN^EfXgN^
/*-------------------------------------------------------------------------*/
CListCtrlEx::CListCtrlEx()
{
	// s̍
	m_ItemHeight = 20;
}

CListCtrlEx::~CListCtrlEx()
{
}

BEGIN_MESSAGE_MAP(CListCtrlEx, CListCtrl)
	//{{AFX_MSG_MAP(CListCtrlEx)
	ON_NOTIFY_REFLECT(NM_SETFOCUS, OnSetfocusKillfocus)
	ON_WM_MEASUREITEM_REFLECT()
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY_REFLECT(NM_KILLFOCUS, OnSetfocusKillfocus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*-------------------------------------------------------------------------*/
// Initial			ݒ
/*-------------------------------------------------------------------------*/
void	CListCtrlEx::Initial(UINT inItemHeight)
{
	// s̍w
	m_ItemHeight = inItemHeight;

	// ̒ǉ
	InitialSelf();

}

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx bZ[W nh

/*-------------------------------------------------------------------------*/
// OnSetfocusKillfocus		tH[JX
/*-------------------------------------------------------------------------*/
void CListCtrlEx::OnSetfocusKillfocus(NMHDR* /*pNMHDR*/, LRESULT* pResult) 
{
	int theItem=GetNextItem(-1, LVNI_FOCUSED);
	if (theItem!=-1) {
		CRect theRectItem;
		GetItemRect(theItem, theRectItem, LVIR_BOUNDS);
		InvalidateRect(theRectItem, FALSE);
	}
	UpdateWindow();
	
	*pResult = 0;
}

/*-------------------------------------------------------------------------*/
// MeasureItem	ACe̍߂
/*-------------------------------------------------------------------------*/
void CListCtrlEx::MeasureItem(
	LPMEASUREITEMSTRUCT lpMIS)
{
	/*
	ON_WM_MEASUREITEM_REFLECT() ̋LqYꂸ
	LqȂƁAnhȂ
	*/
	
	// s̍ύX
	lpMIS->itemHeight = m_ItemHeight;
}

/*-------------------------------------------------------------------------*/
// DrawItem					`揈
/*-------------------------------------------------------------------------*/
void CListCtrlEx::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC* pDC=CDC::FromHandle(lpDrawItemStruct->hDC);
	int nDC=pDC->SaveDC();
	int nItemState=GetItemState(lpDrawItemStruct->itemID, LVIS_FOCUSED|LVIS_SELECTED);
	CRect theRectItem;
	GetItemRect(lpDrawItemStruct->itemID, theRectItem, LVIR_BOUNDS);
	if (nItemState&LVIS_SELECTED) {
		pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		pDC->FillSolidRect(theRectItem, ::GetSysColor(COLOR_HIGHLIGHT));
	} else {
		pDC->FillSolidRect(theRectItem, GetBkColor());
		// ɐFt
		CBrush br(RGB_LIST_ODD_COLOR);
		if ((lpDrawItemStruct->itemID % 2) == 0)	{
			pDC->FillRect(theRectItem,&br);
		}
	}
	CRect theRect(theRectItem.left, theRectItem.top, theRectItem.left, theRectItem.bottom);
	LV_COLUMN lvc;
	lvc.mask=LVCF_FMT|LVCF_WIDTH;
	for (int theColumn=0;GetColumn(theColumn, &lvc);theColumn++) {
		theRect.left=theRect.right;
		theRect.right+=lvc.cx;
		if (DrawColSelf(pDC,theRect,lpDrawItemStruct->itemID,theColumn,(nItemState&LVIS_SELECTED)))	{
			// TuNXō悵ꍇ
		}
		else	{
			char theText[MAX_PATH];
			int theLen=GetItemText(lpDrawItemStruct->itemID, theColumn, theText, sizeof(theText));
			if (theLen==0) {
				continue;
			}
			if (GetStringWidth(theText)<=(lvc.cx-12)) { 
				switch (lvc.fmt&LVCFMT_JUSTIFYMASK) {
				case LVCFMT_RIGHT:
					pDC->DrawText(theText, CRect(theRect.left+6, theRect.top, theRect.right-6, theRect.bottom), DT_RIGHT|DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
					break;
				case LVCFMT_CENTER:
					pDC->DrawText(theText, CRect(theRect.left+6, theRect.top, theRect.right-6, theRect.bottom), DT_CENTER|DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
					break;
				default:
					pDC->DrawText(theText, CRect(theRect.left+6, theRect.top, theRect.right-6, theRect.bottom), DT_LEFT|DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
					break;
				}
			} else {
				for (LPSTR theTextP=&theText[theLen];theTextP!=theText;theTextP=::CharPrevExA(0, theText, theTextP, 0)) {
					::lstrcpy(theTextP, "...");
					if (GetStringWidth(theText)<=(lvc.cx-5)) {
						break;
					}
				}
				pDC->DrawText(theText, CRect(theRect.left+6, theRect.top, theRect.right, theRect.bottom), DT_LEFT|DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
			}
		}
	}
	if (nItemState&LVIS_FOCUSED && GetFocus()==this) {
		pDC->DrawFocusRect(theRectItem);
	}
	pDC->RestoreDC(nDC);
}

/*-------------------------------------------------------------------------*/
// GetCurSel		ݑI̍sԍo
/*-------------------------------------------------------------------------*/
INT	CListCtrlEx::GetCurSel()
{
	INT	result = -1;
	if (GetSelectedCount() == 1)	{
		// IP̂Ƃ̂ݏ
		result = GetNextItem(-1,LVNI_SELECTED );
	}
	return result;
}

/*-------------------------------------------------------------------------*/
// SetCurSel		w̍sԍI
/*-------------------------------------------------------------------------*/
BOOL	CListCtrlEx::SetCurSel(INT inSelectNo,BOOL isBeSee)
{
	BOOL	result = FALSE;
	LV_ITEM	theItem;
	if (inSelectNo >= 0 && inSelectNo < GetItemCount())	{
		// I
		theItem.stateMask   = LVIS_SELECTED + LVIS_FOCUSED;
		theItem.state = LVIS_SELECTED + LVIS_FOCUSED;
		result = SetItemState(inSelectNo,&theItem);
	}
	else if (inSelectNo < 0)	{
		// I
		INT	theNowSelect = GetCurSel();
		if (theNowSelect >= 0)	{
			theItem.stateMask   = LVIS_SELECTED + LVIS_FOCUSED;
			theItem.state = 0x0;
			result = SetItemState(inSelectNo,&theItem);
		}
		else result = TRUE;
		return result;
	}
	if (result && isBeSee)	BeSee(inSelectNo);	// IʒuɃr[ړ
	return	result;
}

/*-------------------------------------------------------------------------*/
// BeSee				wsԍʒuɃr[ړ
/*-------------------------------------------------------------------------*/
void	CListCtrlEx::BeSee(INT inLineNo)
{
	if (inLineNo >= 0 && inLineNo < GetItemCount())	{
		// ݃r[̐擪ɕ\Ăso
		INT	theTopNo = GetTopIndex();
		// Ps̍߂
		CRect	theItemRect;
		GetItemRect(theTopNo,&theItemRect,LVIR_BOUNDS );
		INT	theItemHeight = theItemRect.bottom - theItemRect.top;
		// ݃r[̍Ōɕ\Ăso
		CRect	theClientRect;
		GetClientRect(&theClientRect);
		INT	theLastNo = theClientRect.bottom / theItemHeight + theTopNo - 1;
		// \sԍ͈̔͂Ɏwsԍꍇ̓r[ړ
		if ((inLineNo < theTopNo) || (inLineNo > theLastNo))	{
			CSize theMoveSize(0,0);
			theMoveSize.cy = (inLineNo - theTopNo - 1) * theItemHeight;
			Scroll(theMoveSize);
		}
	}
}

/*-------------------------------------------------------------------------*/
// RedrawOfLineNo			wsԍč
/*-------------------------------------------------------------------------*/
void	CListCtrlEx::RedrawOfLineNo(INT inLineNo)
{
	if (inLineNo >= 0 && inLineNo < GetItemCount())	{
		// ws̋`vZ
		CRect	theItemRect;
		if (GetItemRect(inLineNo,&theItemRect,LVIR_BOUNDS))	{
			// `𖳌ɂAčv
			RedrawWindow(&theItemRect);
		}
	}
}

