/////////////////////////////////////////////////////////////////////////////
//
// Program by Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// JJUpdateList.cpp
//
// XgRg[̃|[gr[sIgNX
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "JJUpdate.h"
#include "JJUpdateList.h"
#include "XString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B CJJUpdateApp IuWFNg

extern	CJJUpdateApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CJJUpdateList

/*-------------------------------------------------------------------------*/
// CListCtrlEx		RXgN^
/*-------------------------------------------------------------------------*/
CJJUpdateList::CJJUpdateList()
{
	// ȍ
	m_ListDataTbl	= NULL;
}

/*-------------------------------------------------------------------------*/
// ~CListCtrlEx		fXgN^
/*-------------------------------------------------------------------------*/
CJJUpdateList::~CJJUpdateList()
{
	// Xgf[^̔j
	PurgeListData();
}

BEGIN_MESSAGE_MAP(CJJUpdateList, CListCtrlEx)
	//{{AFX_MSG_MAP(CJJUpdateList)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*-------------------------------------------------------------------------*/
// PurgeListData	Xgf[^̔j
/*-------------------------------------------------------------------------*/
void	CJJUpdateList::PurgeListData()
{
	// Xg폜
	LIST_DATA_TBL*	theItemP = m_ListDataTbl;
	LIST_DATA_TBL*	theNextP = NULL;
	while (theItemP)	{
		
		// TODO:
		// Xgɓ镶̃GAj
		// ɍ\̂ɍ킹ĕύX邱
		if (theItemP->FilePath)		delete [] theItemP->FilePath;
		if (theItemP->FileName)		delete [] theItemP->FileName;
		if (theItemP->NowYmd)		delete [] theItemP->NowYmd;
		if (theItemP->UpdateYmd)	delete [] theItemP->UpdateYmd;

		// jO next ۑĂ
		theNextP = theItemP->NextItemP;
		delete theItemP;
		theItemP = theNextP;
	}
	m_ListDataTbl = NULL;
}

/*-------------------------------------------------------------------------*/
// InitialSelf		ݒǉiz֐̎j
/*-------------------------------------------------------------------------*/
void	CJJUpdateList::InitialSelf()
{
	// ̃Rg[ Initial \bhĂԂƂɁǍォĂ΂
	// ɂ́ARg[̏ǉ

	LVCOLUMN	theLvc;
	theLvc.mask		= LVCF_TEXT + LVCF_WIDTH + LVCF_FMT;
	theLvc.fmt		= LVCFMT_RIGHT;
	theLvc.pszText	= _T("No.");
	theLvc.cx		= 30;
	InsertColumn(0,&theLvc);
	theLvc.fmt		= LVCFMT_LEFT;
	theLvc.pszText	= _T("߽ / ̧ٖ");
	theLvc.cx		= 185;
	InsertColumn(1,&theLvc);
	theLvc.fmt		= LVCFMT_CENTER;
	theLvc.pszText	= _T(":۰ :");
	theLvc.cx		= 120;
	InsertColumn(2,&theLvc);
	theLvc.fmt		= LVCFMT_RIGHT;
	theLvc.pszText	= _T("");
	theLvc.cx		= 60;
	InsertColumn(3,&theLvc);
	theLvc.fmt		= LVCFMT_CENTER;
	theLvc.pszText	= _T("");
	theLvc.cx		= 50;
	InsertColumn(4,&theLvc);

	// Xg쐬
	MakeList();

}

/*-------------------------------------------------------------------------*/
// MakeList			\f[^̍쐬
/*-------------------------------------------------------------------------*/
void	CJJUpdateList::MakeList()
{
	// PxȏĂ΂邱ƂlāAf[^j
	PurgeListData();
	
	// XVt@C̎擾
	LIST_DATA_TBL*	theLastP = NULL;
	LIST_DATA_TBL*	theItemP = NULL;
	INT	theNo = 0;
	CString	theParam,theFStr = _T("F01");
	theParam = theApp.GetProfileString(_T("UpdateFiles"),theFStr);
	while (!theParam.IsEmpty())	{

		// Xg̐VGA쐬
		theNo++;
		theItemP = new LIST_DATA_TBL;
		ASSERT(theItemP != NULL);
		memset(theItemP,0x0,sizeof(LIST_DATA_TBL));

		// p^pXƃt@Cɕ
		CString	theFileName,thePathName = _T("");
		INT	theSPos = theParam.Find(_T(","));
		if (theSPos > 0)	{
			theFileName = theParam.Left(theSPos);
			thePathName = theParam.Mid(theSPos+1);
		}
		else	{
			theFileName = theParam;
		}

		// XgɃf[^Rs[
		theItemP->FilePath	= new TCHAR[thePathName.GetLength() + 1];
		strcpy(theItemP->FilePath,thePathName);
		theItemP->FileName	= new TCHAR[theFileName.GetLength() + 1];
		strcpy(theItemP->FileName,theFileName);
		theItemP->NowYmd	= new TCHAR[20];	// "yyyy/mm/dd hh:mm:ss"̓̈
		theApp.GetFileUpdateYmd(0,thePathName+theFileName,
						theItemP->NowYmd,20,&theItemP->NowSize);
		theItemP->UpdateYmd	= new TCHAR[20];	// "yyyy/mm/dd hh:mm:ss"̓̈
		memset(theItemP->UpdateYmd,0x0,20);
		theItemP->UpdateSize = 0;
		theItemP->Status	 = 0;

		// N̍쐬
		if (m_ListDataTbl == NULL)	{
			// 擪
			m_ListDataTbl = theItemP;
		}
		else	{
			// Qڈȍ~
			theLastP->NextItemP = theItemP;
		}
		theLastP = theItemP;	// Ō̃Nۑ

		// ̃t@C
		theFStr.Format(_T("F%2.2d"),theNo+1);
		theParam = theApp.GetProfileString(_T("UpdateFiles"),theFStr);
	}

	// Xg\쐬
	MakeListCtrl();
}

/*-------------------------------------------------------------------------*/
// MakeListCtrl		Rg[Xg\쐬
/*-------------------------------------------------------------------------*/
void	CJJUpdateList::MakeListCtrl()
{
	// ̃Xg\j
	DeleteAllItems();

	// XgRg[փ_~[̃f[^(NULLeLXg)}
	// f[^̎Ԃ́Am_ListDataTbl

	// J̎擾
	CHeaderCtrl*	theHCtrlP = GetHeaderCtrl();
	ASSERT(theHCtrlP != NULL);
	INT	theColCount = theHCtrlP->GetItemCount();

	// Xgf[^XLēo^
	LV_ITEM		theLvi;
	LIST_DATA_TBL*	theItemP = m_ListDataTbl;
	INT	i = 0;
	while (theItemP)	{

		// ŏ̃ACe}im_ListDataTbl ̃ACeAhXݒj
		theLvi.mask = LVIF_TEXT + LVIF_PARAM;
		theLvi.iItem	= i++;
		theLvi.iSubItem	= 0;
		theLvi.pszText	= "";				// NULLeLXg
		theLvi.lParam	= (LPARAM)theItemP;	// ACeAhXݒ
		InsertItem(&theLvi);

		// QJڈȍ~̃ACe}
		theLvi.mask = LVIF_TEXT;
		for (INT j=1;j<theColCount;j++)	{
			theLvi.iSubItem		= j;
			theLvi.pszText		= "";		// NULLeLXg
			SetItem(&theLvi);
		}

		// ̃N
		theItemP = theItemP->NextItemP;
	}

}

/*-------------------------------------------------------------------------*/
// DrawColSelf		J̍揈iz֐̎j
/*-------------------------------------------------------------------------*/
BOOL	CJJUpdateList::DrawColSelf(
				CDC* pDC,CRect inItemRect,INT inLineNo,INT inColNo,BOOL inIsSelect)
{
	// ̑Ώۃf[^̃AhXo
	LIST_DATA_TBL*	theItemP = GetListDataOfLineNo(inLineNo);
	if (theItemP == NULL)	return FALSE;

	// J̎o
	LV_COLUMN theColInfo;
	GetColumn(inColNo,&theColInfo);

	// ̈߂
	CRect	theRc = inItemRect;
	theRc.DeflateRect(6,2);

	// tHg̐ݒ
	CFont	theFont;
	theFont.CreatePointFont(DIALOG_TEXT_FONT_SIZE,DEFAULT_PRO_FONT,pDC);
	CFont*	theOldFontP = pDC->SelectObject(&theFont);

	// TODO:
	// JPʂ̍揈
	// LTvł́AMakeList œKɍ쐬Tvf[^
	// tHgύX΁Ȃ傫ύX\iAGDI\[X̏YɒӁj
	// CDCւ̍ƂȂ̂ŁArbg}bv\

	switch	(inColNo)	{
		case 0:	// PJځiNo.j
			{
				XString	theNum(inLineNo+1);
				pDC->SetTextColor(RGB_BLUE);
				pDC->DrawText(theNum,theRc,
					DT_RIGHT | DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
			}
			break;
		case 1:	// QJځi̧ٖj
			{
				pDC->SetTextColor(RGB_BLUE);
				CString	thePath = _T("./");
				thePath += theItemP->FilePath;
				thePath.Replace(_T("\\"),_T("/"));
				pDC->DrawText(thePath,theRc,
					DT_LEFT|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
				theRc.top += 15;
				pDC->DrawText(theItemP->FileName,theRc,
					DT_LEFT|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
			}
			break;
		case 2:	// RJځiXVj
			{
				pDC->SetTextColor(RGB_BLUE);
				pDC->DrawText(theItemP->NowYmd,theRc,
					DT_CENTER|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
				theRc.top += 15;
				pDC->SetTextColor(RGB_RED);
				if (_tcscmp(theItemP->NowYmd,theItemP->UpdateYmd) == 0)	{
					pDC->SetTextColor(RGB_GLAY);
				}
				pDC->DrawText(theItemP->UpdateYmd,theRc,
					DT_CENTER|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
			}
			break;
		case 3:	// SJځiށj
			{
				if (theItemP->NowSize > 0)	{
					XString	theNowSize(theItemP->NowSize);
					pDC->SetTextColor(RGB_BLUE);
					pDC->DrawText(theNowSize,theRc,
						DT_RIGHT|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
				}
				theRc.top += 15;
				if (theItemP->UpdateSize > 0)	{
					XString	theUpdateSize(theItemP->UpdateSize);
					pDC->SetTextColor(RGB_RED);
					if (theItemP->NowSize == theItemP->UpdateSize)	{
						pDC->SetTextColor(RGB_GLAY);
					}
					pDC->DrawText(theUpdateSize,theRc,
						DT_RIGHT|DT_SINGLELINE|DT_NOPREFIX|DT_TOP);
				}
			}
			break;
		case 4:	// TJځij
			{
				CString	theStr;
				if (theItemP->Status == 0)	{
					theStr = _T("|");
					pDC->SetTextColor(RGB_BLACK);
				}
				else if (theItemP->Status == 1)	{
					theStr = _T("X");
					pDC->SetTextColor(RGB_BLUE);
				}
				else if (theItemP->Status == 2)	{
					theStr = _T("");
					pDC->SetTextColor(RGB_GLAY);
				}
				else if (theItemP->Status == 3)	{
					theStr = _T("");
					pDC->SetTextColor(RGB_DGREEN);
				}
				else	{
					theStr = _T("~");
					pDC->SetTextColor(RGB_RED);
				}
				pDC->DrawText(theStr,theRc,
					DT_CENTER|DT_SINGLELINE|DT_NOPREFIX|DT_VCENTER);
			}
			break;
	}


	// eLXgJ[ɖ߂
	pDC->SetTextColor(RGB_BLACK);

	// tHgɖ߂
	if (theOldFontP)	pDC->SelectObject(theOldFontP);
	theOldFontP = NULL;

	return	TRUE;	// TuNXō悵
}

/*-------------------------------------------------------------------------*/
// GetListDataOfLineNo	wsԍ̃Xgf[^o
/*-------------------------------------------------------------------------*/
LIST_DATA_TBL*	CJJUpdateList::GetListDataOfLineNo(INT inLineNo)
{
	if (inLineNo >= GetItemCount() || inLineNo < 0)	return NULL;

	// Ώۃf[^̃AhXo
	return	(LIST_DATA_TBL*)GetItemData(inLineNo);
}

	// wf[^AhX̃Xgf[^Iɂ
/*-------------------------------------------------------------------------*/
// SetSelectOfDataAddr	wf[^AhX̃Xgf[^Iɂ
/*-------------------------------------------------------------------------*/
void	CJJUpdateList::SetSelectOfDataAddr(LIST_DATA_TBL* inDataAddr)
{
	// If[^
	if (inDataAddr == NULL)	return;
	for (INT i=0;i<GetItemCount();i++)	{
		// \f[^ŏI
		if (GetListDataOfLineNo(i) == inDataAddr)	{
			SetCurSel(i);
			break;
		}
	}
}



/////////////////////////////////////////////////////////////////////////////
// CJJUpdateList bZ[W nh


