// UrlStatic.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////
//
// Program by Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2004.04.07
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "UrlStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUrlStatic

/*-------------------------------------------------------------------------*/
// CUrlStatic			RXgN^EfXgN^
/*-------------------------------------------------------------------------*/
CUrlStatic::CUrlStatic()
{
	// wJ[\ǂݍ
	_TCHAR theWinPath[MAX_PATH];
	::GetWindowsDirectory(theWinPath, MAX_PATH - 13);
	_tcscat(theWinPath, _T("\\winhlp32.exe"));
	HINSTANCE hInstHelp = ::LoadLibrary(theWinPath);
	if(hInstHelp)	{
		m_CursorH = CopyCursor(::LoadCursor(hInstHelp,MAKEINTRESOURCE(106)));
		::FreeLibrary(hInstHelp);
	}
    else	{
		m_CursorH = ::LoadCursor(NULL,IDC_ARROW);
	}
	// wiuV̍쐬
    m_Brush.CreateSolidBrush(::GetSysColor(COLOR_3DFACE));
}

CUrlStatic::~CUrlStatic()
{
}


BEGIN_MESSAGE_MAP(CUrlStatic, CStatic)
	//{{AFX_MSG_MAP(CUrlStatic)
	ON_WM_CTLCOLOR_REFLECT()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUrlStatic bZ[W nh

/*-------------------------------------------------------------------------*/
// CtlColor				eLXg̊OςύX
/*-------------------------------------------------------------------------*/
HBRUSH CUrlStatic::CtlColor(CDC* pDC, UINT /*nCtlColor*/) 
{
	// ŏɌĂ΂ꂽtHg̐ݒ
	if(!m_Font.m_hObject)	{
		// tHg̐ݒij
		LOGFONT theLogFont;
		GetFont()->GetLogFont(&theLogFont);
		theLogFont.lfUnderline = TRUE;
		m_Font.CreateFontIndirect(&theLogFont);
		SetFont(&m_Font, FALSE);
		Invalidate();
	}

	// Fݒ
	pDC->SetTextColor(RGB(0, 0, 255));
	pDC->SetBkColor(::GetSysColor(COLOR_3DFACE));

	return m_Brush; 
}

/*-------------------------------------------------------------------------*/
// OnSetCursor			J[\ύX
/*-------------------------------------------------------------------------*/
BOOL CUrlStatic::OnSetCursor(CWnd* /*pWnd*/, UINT /*nHitTest*/, UINT /*message*/) 
{
	// wJ[\ݒ
    ::SetCursor(m_CursorH);
    return TRUE;
}

/*-------------------------------------------------------------------------*/
// OnLButtonUp			{^UPURLփWv
/*-------------------------------------------------------------------------*/
void CUrlStatic::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CString theUrl;
	GetWindowText(theUrl);
	::ShellExecute(NULL,_T("open"),theUrl,NULL,NULL,SW_SHOWNORMAL);   

	// {
	CStatic::OnLButtonUp(nFlags, point);
}
